#include <sqlite3.h>

int size_of_sqlite3_file (void)
{
    return sizeof sqlite3_file;
}

int size_of_sqlite3_io_methods (void)
{
    return sizeof sqlite3_io_methods;
}

void hs2c_sqlite3_file (sqlite3_file *p,
    const struct sqlite3_io_methods *p1)
{
    p->pMethods = p1;
}

void hs2c_sqlite_io_methods (sqlite_io_methods *p,
    int p1,
    int (*p2)(sqlite3_file*),
    int (*p3)(sqlite3_file*,void*,int,sqlite3_int64),
    int (*p4)(sqlite3_file*,const void*,int,sqlite3_int64),
    int (*p5)(sqlite3_file*,sqlite3_int64),
    int (*p6)(sqlite3_file*,int),
    int (*p7)(sqlite3_file*,sqlite3_int64*),
    int (*p8)(sqlite3_file*,int),
    int (*p9)(sqlite3_file*,int),
    int (*p10)(sqlite3_file*,int*),
    int (*p11)(sqlite3_file*,int,void*),
    int (*p12)(sqlite3_file*),
    int (*p13)(sqlite3_file*))
{
    p->iVersion = p1;
    p->xClose = p2;
    p->xRead = p3;
    p->xWrite = p4;
    p->xTruncate = p5;
    p->xSync = p6;
    p->xFileSize = p7;
    p->xLock = p8;
    p->xUnlock = p9;
    p->xCheckReservedLock = p10;
    p->xFileControl = p11;
    p->xSectorSize = p12;
    p->xDeviceCharacteristics = p13;
}

void c2hs_sqlite3_file (sqlite3_file *p,
    const struct sqlite3_io_methods **p1)
{
    p->pMethods = p1;
}

void c2hs_sqlite_io_methods (sqlite_io_methods *p,
    int *p1,
    int (**p2)(sqlite3_file*),
    int (**p3)(sqlite3_file*,void*,int,sqlite3_int64),
    int (**p4)(sqlite3_file*,const void*,int,sqlite3_int64),
    int (**p5)(sqlite3_file*,sqlite3_int64),
    int (**p6)(sqlite3_file*,int),
    int (**p7)(sqlite3_file*,sqlite3_int64*),
    int (**p8)(sqlite3_file*,int),
    int (**p9)(sqlite3_file*,int),
    int (**p10)(sqlite3_file*,int*),
    int (**p11)(sqlite3_file*,int,void*),
    int (**p12)(sqlite3_file*),
    int (**p13)(sqlite3_file*))
{
    *p1 = p->iVersion;
    *p2 = p->xClose;
    *p3 = p->xRead;
    *p4 = p->xWrite;
    *p5 = p->xTruncate;
    *p6 = p->xSync;
    *p7 = p->xFileSize;
    *p8 = p->xLock;
    *p9 = p->xUnlock;
    *p10 = p->xCheckReservedLock;
    *p11 = p->xFileControl;
    *p12 = p->xSectorSize;
    *p13 = p->xDeviceCharacteristics;
}

